PTSNAME(3)

NAME
ptsname, ptsname_r - get the name of the slave pseudo-terminal

SYNOPSIS
#define _XOPEN_SOURCE
#include <stdlib.h>

char *ptsname(int fd);

#define _GNU_SOURCE
#include <stdlib.h>

char *ptsname_r(int fd, char *buf, size_t buflen);

DESCRIPTION
The ptsname() function returns the name of the slave pseudo-terminal (pty) device corresponding to the master referred to by fd. The ptsname_r() function is the reentrant equivalent of ptsname(). It returns the name of the slave pseudo-terminal device as a null-terminated string in the buffer pointed to by buf. The buflen argument specifies the number of bytes available in buf.

RETURN VALUE
On success, ptsname() returns a pointer to a string in static storage which will be overwritten by subsequent calls. This pointer must not be freed. On failure, a NULL pointer is returned. On success, ptsname_r() returns 0. On failure, a non-zero value is returned and errno is set to indicate the error.

ERRORS

EINVAL
    (ptsname_r() only) buf is NULL.

ENOTTY
    fd does not refer to a pseudo-terminal master device.

ERANGE
    (ptsname_r() only) buf is too small.

CONFORMING TO
ptsname() is part of the Unix98 pseudo-terminal support (see pts(4)). This function is specified in POSIX.1-2001. ptsname_r() is a Linux extension. A version of this function is documented on Tru64 and HP-UX, but on those implementations, -1 is returned on error, with errno set to indicate the error. Avoid using this function in portable programs.

SEE ALSO
grantpt(3), posix_openpt(3), ttyname(3), unlockpt(3), pts(4), feature_test_macros(7), pty(7)